from zope.interface import Interface
from zope.interface import implements
from zope import schema
from zope.formlib import form

from zope.component.interfaces import IObjectEvent

from plone.portlets.interfaces import IPortletDataProvider
from plone.app.portlets.portlets import base
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from Products.CMFCore.utils import getToolByName

from sixfeetup.tips.portlet import TipsPortletMessageFactory as _

class ITipsPortlet(IPortletDataProvider):
    """Render either a specific or random tip 
       (page/Document content) into a portlet.
    """

class Assignment(base.Assignment):
    """Portlet assignment.
    This is what is actually managed through the portlets UI and associated
    with columns.
    """

    implements(ITipsPortlet)

    def __init__(self):
        pass

    @property
    def title(self):
        """This property is used to give the title of the portlet in the
        "manage portlets" screen.
        """
        return "Six Feet Up Tips Portlet"

class Renderer(base.Renderer):
    """Portlet renderer.

    This is registered in configure.zcml. The referenced page template is
    rendered, and the implicit variable 'view' will refer to an instance
    of this class. Other methods can be added and referenced in the template.
    """

    render = ViewPageTemplateFile('tipsportlet.pt')

    def getTips(self):
        """ Return the list of speakers in alphabetical order by last name """
        catalog = getToolByName(self.context, 'portal_catalog')
        results = catalog.searchResults(path='/Plone/tips',
                                        portal_type='Document',
                                        featured_state='featured')

        return results

# NOTE: If this portlet does not have any configurable parameters, you can
# inherit from NullAddForm and remove the form_fields variable.

class AddForm(base.NullAddForm):
    """Portlet add form.

    This is registered in configure.zcml. The form_fields variable tells
    zope.formlib which fields to display. The create() method actually
    constructs the assignment that is being added.
    """

    def create(self):
        return Assignment()

# NOTE: IF this portlet does not have any configurable parameters, you can
# remove this class definition and delete the editview attribute from the
# <plone:portlet /> registration in configure.zcml

